#include <Servo.h>

int posBack = 80;
int posFront = 80;
Servo backLegs;
Servo frontLegs;

const int trigPin = 5;
const int echoPin = 6;

long duration;
int distance;

int mode = 0;
int counter = 0;
int isObstacle = 0;
int wasObstacle = 0;

unsigned long dt = 0;

void(* resetFunc) (void) = 0;

void modeSwitcher() {
  if (mode == 0) {

    if (isObstacle != wasObstacle && millis() - dt > 200 && millis() - dt < 2000) {
      counter++;

      wasObstacle = isObstacle;
      dt = millis();
    }
    if (millis() - dt > 2000) {
      counter = 0;
      dt = millis();
    }


    if (counter >= 8) {
      mode = 1;

      counter = 0;
      dt = millis();
      Serial.println("MOVE");
      backLegs.attach(4);
      frontLegs.attach(3);

    }
  }
  else {
    if (distance > 10) dt = millis();
    else if (millis() - dt > 2000) {
      Serial.println("STOP");
      backLegs.write(90);
      frontLegs.write(90);
      delay(100);
      backLegs.detach();
      frontLegs.detach();
      mode = 0;
      dt = millis();
    }
  }
}

void checkDistance()
{
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH, 10000);
  delayMicroseconds(10000 - duration);
  // Calculating the distance
  distance = duration * 0.034 / 2;
  Serial.println(distance);
  //Serial.println(counter);
  if (distance < 15 && distance > 0) isObstacle = 1;
  else if (distance >= 15 || distance == 0)isObstacle = 0;
  modeSwitcher();

}

void go_forward() {
  for (posBack = 50; posBack <= 130; posBack += 7) {
    backLegs.write(posBack);
    delay(10);

  }
  checkDistance();
  for (posFront = 50; posFront <= 130; posFront += 7) {
    frontLegs.write(posFront);
    delay(10);



  }
  checkDistance();
  for (posBack = 130; posBack >= 50; posBack -= 7) {
    backLegs.write(posBack);
    delay(10);


  }
  checkDistance();
  for (posFront = 130; posFront >= 50; posFront -= 7) {
    frontLegs.write(posFront);
    delay(10);
  }
  checkDistance();
}

void go_backward() {

  for (posBack = 50; posBack <= 130; posBack += 7) {
    backLegs.write(posBack);
    delay(10);

  }
  checkDistance();

  for (posFront = 130; posFront >= 50; posFront -= 7) {
    frontLegs.write(posFront);
    delay(10);

  }
  checkDistance();

  for (posBack = 130; posBack >= 50; posBack -= 7) {
    backLegs.write(posBack);
    delay(10);

  }
  checkDistance();

  for (posFront = 50; posFront <= 130; posFront += 7) {
    frontLegs.write(posFront);
    delay(10);

  }
  checkDistance();
}

void setup() {
  pinMode(2, OUTPUT);
  pinMode(19, OUTPUT);
  pinMode(20, OUTPUT);
  pinMode(21, OUTPUT);
  digitalWrite(2, 0);

  digitalWrite(19, 1);
  digitalWrite(20, 1);
  digitalWrite(21, 1);

  //backLegs.attach(4);
  //frontLegs.attach(3);

  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);

  //backLegs.attach(4);
  //frontLegs.attach(3);
  Serial.begin (9600);

}

void loop() {
  checkDistance();
  //Serial.println(distance);
  if (millis() > 4294500000) resetFunc();

  if (mode)
    if (!isObstacle) {

      go_forward();
    }
    else {
      delay(1000);
      for (int i = 0; i < 5; i++)
        go_backward();
    }



}
